



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Ansible安装配置Nginx</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Ansible安装配置Nginx</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:31:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、思路</strong></p>
<p>现在一台机器上编译安装好nginx、打包，然后在用ansible去下发</p>
<p>cd /etc/ansible 进入ansible配置文件目录</p>
<p>mkdir roles/{common,install}/{handlers,files,meta,tasks,templates,vars} &ndash;pv</p>
<p>目录说明：</p>
<p>roles目录下面有两个角色，common为一些准备操作，install为安装nginx的操作。每个角色下面又有几个目录，handlers下面是当前发生改变时要执行的操作，通常用在配置文件发生改变，重启服务。files为安装时用到的一些文件，meta为说明信息，说明角色依赖等信息，tasks里面是核心的配置文件，templates通常存一些配置文件，启动监本等模板，vars下为定义的变量</p>
<p>进入install目录</p>
<p><strong>二、Ansible安装Nginx(操作目录/etc/ansible/nginx_install)</strong></p>
<p>/etc/ansible/nginx_install/roles/install/files目录下</p>
<p>定义common的tasks，nginx是需要依赖包的</p>
<p>cd /etc/ansible/nginx_install/</p>
<p># vim roles/common/tasks/main.yml</p>
<p>- name: install initializtion require software</p>
<p>yum: name={{ item }} state=installed</p>
<p>with_items:</p>
<p>- zlib-devel</p>
<p>- openssl-devel</p>
<p>- pcre-devel</p>
<p>将编译好的配置文件放到roles/install/files/下</p>
<p>cp /usr/local/nginx.tar.gz files/</p>
<p>将配置文件和启动脚本放到roles/install/templates/下</p>
<p>cp /usr/local/nginx/conf/nginx.conf templates/</p>
<p>cp /etc/init.d/nginx templates/</p>
<p>定义安装时所用的变量</p>
<p># vim roles/install/vars/main.yml</p>
<p>nginx_user: www</p>
<p>nginx_basedir: /usr/local/nginx</p>
<p>nginx_port: 80</p>
<p>定义复制文件copy.yml，复制所需的文件</p>
<p># vim roles/install/tasks/copy.yml</p>
<p>- name: Copy Nginx Software</p>
<p>copy: src=nginx.tar.gz dest=/tmp/nginx.tar.gz owner=root group=root</p>
<p>- name: Uncompression Niginx Software</p>
<p>shell: tar zxf /tmp/nginx.tar.gz -C /usr/local</p>
<p>- name: Copy Nginx Start Script</p>
<p>template: src=nginx dest=/etc/init.d/nginx owner=root group=root mode=0755</p>
<p>- name: Copy Nginx Config</p>
<p>template: src=nginx.conf dest={{ nginx_basedir }}/conf/ owner=root group=root mode=0644</p>
<p>定义安装文件install.yml，安装nginx</p>
<p>- name: Create Nginx User</p>
<p>user: name={{ nginx_user }} state=present createhome=no shell=/sbin/nologin</p>
<p>- name: Create /data/logs</p>
<p>shell: mkdir -p /data/logs</p>
<p>- name: Start Nginx Service</p>
<p>service: name=nginx state=started</p>
<p>- name: Add Boot Start Nginx Service</p>
<p>shell: chkconfig --level 2345 nginx on</p>
<p>- name: Delete Nginx compression files</p>
<p>shell: rm -rf /tmp/nginx.tar.gz</p>
<p>定义入口文件main.yml,引用复制文件和安装文件</p>
<p># vim roles/install/tasks/main.yml</p>
<p>- include: copy.yml</p>
<p>- include: install.yml</p>
<p>定义总入口文件</p>
<p># vim install.yml</p>
<p>---</p>
<p>- hosts: fansik</p>
<p>remote_user: root</p>
<p>gather_facts: Ture</p>
<p>roles:</p>
<p>- common</p>
<p>- install</p>
<p>到此就可以用# ansible-playbook install.yml安装了</p>
<p><strong>三、Ansible管理Nginx的配置文件</strong></p>
<p>生产环境中大多时候是需要管理配置文件的，安装软件包只是在初始化环境的时候用一下，创建一个管理nginx配置文件的playbook</p>
<p># mkdir -p /etc/ansible/nginx_config/roles/{new,old}/{files,handlers,vars,tasks}</p>
<p>其中new为更新是用到的，old为回滚是用到的，file下面为nginx.conf和vhosts目录，handlers为启动nginx服务的命令</p>
<p>关于回滚，需要在执行playbook之前备份一下旧的配置，所以老配置文件的管理一定要严格，千万不能随便去修改线上机器的配置，并且要保证new/files下面的配置和线上的配置一样</p>
<p>先把nginx.conf和vhosts目录放到files目录下面</p>
<p>cd /usr/local/nginx/conf</p>
<p>cp -r nginx.conf vhosts /etc/ansible/nginx_conf/roles/new/files</p>
<p>定义变量# vim roles/new/vars/main.yml</p>
<p>nginx_basedir: /usr/local/nginx</p>
<p>定义重新加载nginx服务</p>
<p># vim roles/new/handlers/main.yml</p>
<p>- name: restart nginx</p>
<p>shell: /etc/init.d/nginx reload</p>
<p>定义核心任务# vim roles/new/tasks/main.yml</p>
<p>- name: copy conf file</p>
<p>copy: src={{ item.src }} dest={{ nginx_basedir }}/{{ item.dest }} backup=yes owner=root group=root mode=0644</p>
<p>with_items:</p>
<p>- { src: nginx.conf, dest: conf/nginx.conf }</p>
<p>- { src: vhosts, dest: conf/ }</p>
<p>notify: restart nginx</p>
<p>定义更新总入口文件# vim update.yml</p>
<p>---</p>
<p>- hosts: slave.fansik.com</p>
<p>user: root</p>
<p>roles:</p>
<p>- new</p>
<p>定义回滚总入口文件# vim backup.yml</p>
<p>---</p>
<p>- hosts: slave.fansik.com</p>
<p>user: root</p>
<p>roles:</p>
<p>- old</p>
<p>更新之前先</p>
<p># rsync -av roles/new/files/ roles/old/files/</p>
<p><strong>四、自动化部署的样例库</strong></p>
<p>先安装git</p>
<p># yum -y install git</p>
<p># git clone git://github.com/dl528888/ansible-examples.git</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kyjx69.html">iOS开发之----常用函数和常数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjjj1y9.html">poj 2653 （线段相交判断）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7w0gq.html">PenetrationTest</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyx1k8.html">Java基础知识强化14：Java死亡竞赛题目解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1z70z9.html">BZOJ1013 球形空间产生器sphere</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm6zrx9.html">Android Studio添加应用作为依赖时报错Error&colon;Dependency MonthText&colon;xlistview&colon;unspecified on project app resolves to an APK archive which is not supported as a compilation dependency&period; File&colon; 及其解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rgk38.html">URL伪静态设置 &lpar;apache2&period;4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0r0g9.html">Introduction to Probability &lpar;5&rpar; Continus random variable</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp12yr9.html">【老鸟学算法】包含 min函数的栈设计&mdash;&mdash;java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z00kx9.html">搭建Maven私服那点事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1kjj9.html">统计git代码提交量</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg4ypq.html">在window系统上安装redis服务-Invalid argument during startup&colon; Failed to open the &period;conf</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg7m0q.html">Visual Studio Code（VSCODE）语言设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjol6j9.html">&lbrack;CQOI2017&rsqb;老C的键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd5vye9.html">用xcode9编译出ios越狱机程序使用的dylib</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1g4zg9.html">HTML5 &amp;amp&semi; how to download SVG in js</a>
		</li>
						<li><a href="https://www.batexi.com/a/96061649.html">SqlServer中sqlmaint 实用工具和xp&lowbar;sqlmaint扩展过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm6l0w9.html">VS2013环境生成和调用DLL动态链接库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pm7p479.html">NSData&Tab;数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pm0zvz9.html">6、CSS基础 part-4</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4yzg63q.html">【STL】-deque的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnem0rq.html">seajs 使用 jquery插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv15lxq.html">在同一个页面中加载多个不同的jQuery版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1o1rx9.html">CIO谈：基于K2 BPM平台怎么做报销？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1y4ej9.html">MapReduce数据流（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xyp509.html">POJ  1185 炮兵阵地（经典的状态压缩DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv1djzq.html">java中判断字符串是否为数字的三种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmjop19.html">win7下利用笔记本无线网卡创建AP 组建无线局域网（可以连魔兽，TCP、UDP也没问题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv1d7jq.html">Ogre中Mesh的加载过程详述</a>
			</li>
						<li><a href="https://www.batexi.com/a/96opm2j9.html">jQuery easyui 提示框</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
